#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
#include <Adafruit_NeoPixel.h>
#include <avr/power.h>
#include <math.h>
#define NO_SOUND 0 // make the rests in music

#define PIN            5
#define NUMPIXELS      8

Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);  
Adafruit_NeoPixel strip = Adafruit_NeoPixel(8, PIN, NEO_GRB + NEO_KHZ800);
    
  long xA = -5;
  long xB = -5;
  long xC = 5;
  long xD = 5;
  
//  long yA = 5;
//  long yB = -5;
//  long yC = -5;
//  long yD = 5;
  int ages = 10000000000;
 
const int pingPin = 7;

int timee = 200;

void setup() {
  Serial.begin(9600);
  pwm.begin();
  pwm.setPWMFreq(50);  // Analog servos run at ~60 Hz updates
  pixels.begin();
  yield();
  strip.begin();
  strip.show();
  Set_Neopixels(255,0,0);
  delay(100);
  
  Set_Body_Centre(50, 0,0,-125);


  
  delay(1000);
  
}
void loop()
{
    for(int i=0;i<30;i++){
    Set_Body_Centre(60,i,i,-120);
    Set_Neopixels(0,map(i,0,30,0,255),0);
    delay(5);
  }
    wave(200,1);
  wave(200,1);
  wave(200,1);
  
    for(int i=30;i>0;i--){
    Set_Body_Centre(60,i,i,-120);
    Set_Neopixels(0,map(i,30,0,255,0),0);
    delay(5);
  }
  
  Set_Neopixels(200,0,255);
  Walk_Forwards(2,2,-60);
  Set_Body_Centre(60,0,0,-120);
  delay(250);
  Set_Body_Centre(60,0,0,-100);
  delay(250);
  Set_Body_Centre(60,0,0,-120);
  delay(250);
  Set_Body_Centre(60,0,0,-100);
  delay(250);
  Set_Body_Centre(60,0,0,-120);
  Set_Body_Centre(60,0,0,-120);
  delay(250);
  Set_Body_Centre(60,0,0,-100);
  delay(250);
  Set_Body_Centre(60,0,0,-120);
  delay(250);
  Set_Body_Centre(60,0,0,-100);
  delay(250);
  Set_Body_Centre(60,0,0,-120);
  


  
//
//  Set_Leg_Position_OCartes('A', -100, 0, -20);
//  Set_Leg_Position_OCartes('D', 100, 0, -20);
//  
//  Set_Leg_Position_OCartes('B', 0, -100, -60);
//  Set_Leg_Position_OCartes('C', 0, -100, -20);
  while(1){
    rainbowCycle(10);
   }
  

}

//{
// 
//  
//  for(int i = 0; i<50;i++){
//    Set_Body_Centre(60,0,0,map(i,0,50,20,-5));
//    delay(1);
//  } 
// 
//  for(int i = 1; i<15;i++){
//    Set_Body_Centre(60,0,0,map(i,0,15,-80,-120));
//    delay(1);
//  }  
//   
//  delay(500);

void wave(int iterator, int dlay){
  
  for(int i=0;i<iterator;i++){
    Set_Neopixels(255,200,0);
    Set_j0('B',map(i,0,iterator,100,80));
    if(i<iterator/2){
      Set_j2('B',map(i,0,iterator/2,160,140));
      Set_j1('B',map(i,0,iterator/2,30,20));
    }
    else{
      Set_j2('B',map(i,iterator/2,iterator,140,160));
      Set_j1('B',map(i,iterator/2,iterator,20,30));
    }
    delay(dlay);
  }  
  
  for(int i=0;i<iterator;i++){
    Set_Neopixels(0,255,0);
    Set_j0('B',map(i,0,iterator,80,100));
    if(i<iterator/2){
      Set_j2('B',map(i,0,iterator/2,160,140));
      Set_j1('B',map(i,0,iterator/2,30,20));
    }
    else{
      Set_j2('B',map(i,iterator/2,iterator,140,160));
      Set_j1('B',map(i,iterator/2,iterator,20,30));
    }   
    delay(dlay);
  }

}
